zoukankan      html  css  js  c++  java
  • codeforces_734C_二分

    C. Anton and Making Potions
    time limit per test
    4 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    Anton is playing a very interesting computer game, but now he is stuck at one of the levels. To pass to the next level he has to prepare n potions.

    Anton has a special kettle, that can prepare one potions in x seconds. Also, he knows spells of two types that can faster the process of preparing potions.

    1. Spells of this type speed up the preparation time of one potion. There are m spells of this type, the i-th of them costs bi manapoints and changes the preparation time of each potion to ai instead of x.
    2. Spells of this type immediately prepare some number of potions. There are k such spells, the i-th of them costsdi manapoints and instantly create ci potions.

    Anton can use no more than one spell of the first type and no more than one spell of the second type, and the total number of manapoints spent should not exceed s. Consider that all spells are used instantly and right before Anton starts to prepare potions.

    Anton wants to get to the next level as fast as possible, so he is interested in the minimum number of time he needs to spent in order to prepare at least n potions.

    Input

    The first line of the input contains three integers nmk (1 ≤ n ≤ 2·10^9, 1 ≤ m, k ≤ 2·10^5) — the number of potions, Anton has to make, the number of spells of the first type and the number of spells of the second type.

    The second line of the input contains two integers x and s (2 ≤ x ≤ 2·10^9, 1 ≤ s ≤ 2·10^9) — the initial number of seconds required to prepare one potion and the number of manapoints Anton can use.

    The third line contains m integers ai (1 ≤ ai < x) — the number of seconds it will take to prepare one potion if the i-th spell of the first type is used.

    The fourth line contains m integers bi (1 ≤ bi ≤ 2·10^9) — the number of manapoints to use the i-th spell of the first type.

    There are k integers ci (1 ≤ ci ≤ n) in the fifth line — the number of potions that will be immediately created if the i-th spell of the second type is used. It's guaranteed that ci are not decreasing, i.e. ci ≤ cj if i < j.

    The sixth line contains k integers di (1 ≤ di ≤ 2·10^9) — the number of manapoints required to use the i-th spell of the second type. It's guaranteed that di are not decreasing, i.e. di ≤ dj if i < j.

    Output

    Print one integer — the minimum time one has to spent in order to prepare n potions.

    Examples
    input
    20 3 2
    10 99
    2 4 3
    20 10 40
    4 15
    10 80
    output
    20
    input
    20 3 2
    10 99
    2 4 3
    200 100 400
    4 15
    100 800
    output
    200

    题意:要制造n个物品,制造一个需要x分钟,一共s的技能点,有两种技能,第一种使制造每一个的时间变为指定值,
    第二种瞬间制造指定个数物品,两种技能消耗指定的技能点,每种技能只能用一次。问最短多久能完成任务。

    思路:最短时间为:t*(n-w)。找到它的最小值,枚举第一种技能求出t,因为第二种技能是有序的,
    可以二分查找剩余技能点能使用的w最大的技能。

    注意:有可能不用第一种技能,只用第二种技能。

    #include<iostream>
    #include<cstdio>
    #include<cstring>
    using namespace std;
    #define N 200005
    #define LL long long
    #define INF (4*1e18+5)
    struct One
    {
        int cost,time;
    } one[N];
    
    struct Two
    {
        int cost,num;
    } two[N];
    
    int k;
    int Find(int x)
    {
        int l=0,r=k-1,res=0;
        while(l<=r)
        {
            int mid=(l+r)>>1;
            if(two[mid].cost>x)
                r=mid-1;
            else
            {
                l=mid+1;
                res=two[mid].num;
            }
        }
        return res;
    }
    
    int main()
    {
        int n,m,x,s;
        scanf("%d%d%d%d%d",&n,&m,&k,&x,&s);
        for(int i=0; i<m; i++)
            scanf("%d",&one[i].time);
        for(int i=0; i<m; i++)
            scanf("%d",&one[i].cost);
        for(int i=0; i<k; i++)
            scanf("%d",&two[i].num);
        for(int i=0; i<k; i++)
            scanf("%d",&two[i].cost);
        LL res=x*(LL)(n-Find(s));    //这里特别注意,做的时候这里出错,只用第二种技能或者都不用
       LL time=x,mana=s; for(int i=0; i<m; i++) { time=x,mana=s; if(one[i].cost<=s) { time=one[i].time; mana=s-one[i].cost; } int red=Find(mana); // cout<<mana<<" "<<red<<endl; res=min((LL)time*(n-red),res); } printf("%I64d ",res); return 0; }
    
    
    
     
  • 相关阅读:
    "用脑思考"和"用心感知"
    Oracle 分页查询
    MySQL定时执行存储过程
    java商城小程序收藏
    巴士团小程序
    微信小程序this作用域
    Flink之API的使用(3):Source的使用
    Flink之API的使用(2):Transform算子的使用
    Flink之API的使用(1):Sink的使用
    Flink之基础内容(2):DataStream的创建和使用
  • 原文地址:https://www.cnblogs.com/jasonlixuetao/p/6081843.html
Copyright © 2011-2022 走看看